/*******************************************************************************
 * Copyright (c) 2004, 2005 Actuate Corporation.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * https://www.eclipse.org/legal/epl-2.0/.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 *
 * Contributors:
 *  Actuate Corporation  - initial API and implementation
 *******************************************************************************/
package org.eclipse.birt.report.data.oda.jdbc;

import org.eclipse.datatools.connectivity.oda.IResultSetMetaData;
import org.eclipse.datatools.connectivity.oda.OdaException;

/**
 * special case:if stored procedure does not return the resultset metadata, then
 * a fake resultsetmeta should be constructed
 *
 */

public class SPResultSetMetaData implements IResultSetMetaData {
	/** the JDBC ResultSetMetaData object */
	// private java.sql.ResultSetMetaData rsMetadata;

	/**
	 *
	 * Constructor SPResultSetMetaData(java.sql.ResultSetMetaData rsMeta) use JDBC's
	 * ResultSetMetaData to construct it.
	 *
	 */
	public SPResultSetMetaData(java.sql.ResultSetMetaData rsMeta) throws OdaException {
		/* record down the JDBC ResultSetMetaData object */
		// this.rsMetadata = rsMeta;

	}

	/*
	 * @see org.eclipse.datatools.connectivity.IResultSetMetaData#getColumnCount()
	 */
	@Override
	public int getColumnCount() throws OdaException {
		return 0;
	}

	/*
	 * @see org.eclipse.datatools.connectivity.IResultSetMetaData#getColumnName(int)
	 */
	@Override
	public String getColumnName(int index) throws OdaException {
		return null;
	}

	/*
	 * @see
	 * org.eclipse.datatools.connectivity.IResultSetMetaData#getColumnLabel(int)
	 */
	@Override
	public String getColumnLabel(int index) throws OdaException {
		return null;
	}

	/*
	 * @see org.eclipse.datatools.connectivity.IResultSetMetaData#getColumnType(int)
	 */
	@Override
	public int getColumnType(int index) throws OdaException {
		return 0;
	}

	/*
	 * @see
	 * org.eclipse.datatools.connectivity.IResultSetMetaData#getColumnTypeName(int)
	 */
	@Override
	public String getColumnTypeName(int index) throws OdaException {
		return null;
	}

	/*
	 * @see
	 * org.eclipse.datatools.connectivity.IResultSetMetaData#getColumnDisplayLength(
	 * int)
	 */
	@Override
	public int getColumnDisplayLength(int index) throws OdaException {
		return 0;
	}

	/*
	 * @see org.eclipse.datatools.connectivity.IResultSetMetaData#getPrecision(int)
	 */
	@Override
	public int getPrecision(int index) throws OdaException {
		return 0;
	}

	/*
	 * @see org.eclipse.datatools.connectivity.IResultSetMetaData#getScale(int)
	 */
	@Override
	public int getScale(int index) throws OdaException {
		return 0;
	}

	/*
	 * @see org.eclipse.datatools.connectivity.IResultSetMetaData#isNullable(int)
	 */
	@Override
	public int isNullable(int index) throws OdaException {
		return 0;
	}

}
